image: java:latest

variables:
#for gitlab checkouts
  GITLAB_USER: "ivan.lazarev"

stages:
#all these stages are done in isolated dockers
#so it's not reasonable to split build from checkout and build deps
#  - checkout-deps
#  - build-deps
  - build
  - execute

#checkoutA:
#  stage: checkout-deps
#  script:
#    - echo checking out iq_LOG dependency
#    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/${GITLAB_USER}/iq_Log
#    - ls -la ./iq_Log

#buildA:
#  stage: build-deps
#  script:
#    - echo building dependency A
#    - mkdir ./out
#    - javac ./iq_Log/src/*.java -d ./out
#    - ls -l ./out

build:
  stage: build
  script:
    - mkdir ./out
#checking out and build projectA
    - bash buildA.sh "https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/${GITLAB_USER}/iq_Log" "iq_Log" "./out"
#building project B
    - echo building project B
    - javac src/*.java -cp ./out:./libs/junit-4.12.jar:./libs/hamcrest-all-1.3.jar -d ./out

.execute:
  stage: execute
  script:
    - mkdir ./out
#checking out and build projectA
    - bash buildA.sh "https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/${GITLAB_USER}/iq_Log" "iq_Log" "./out"
#building project B
    - javac src/*.java -cp ./out:./libs/junit-4.12.jar:./libs/hamcrest-all-1.3.jar -d ./out
#running project B
    - java -cp ./out:./libs/junit-4.12.jar:./libs/hamcrest-all-1.3.jar Main

we-have-being-triggered-from-A:
#TODO WHAT DO I NEED IT FOR?????
  stage: build
  script:
    - echo being triggered from A, we can do some conditional jobs here
  only:
    - triggers

we-have-being-called-with-CI-JOB_TOKEN-from-A:
  #TODO WHAT DO I NEED IT FOR?????
  stage: build
  script:
    - echo being called with CI_JOB_TOKEN from A, we can do some conditional jobs here
  only:
    variables:
      - $CI_PIPELINE_SOURCE == "pipeline"
